using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserRole;
namespace CMSMicroservice.Protobuf.Validator.UserRole;

public class CreateNewUserRoleRequestValidator : AbstractValidator<CreateNewUserRoleRequest>
{
    public CreateNewUserRoleRequestValidator()
    {
        RuleFor(model => model.RoleId)
            .NotNull();
        RuleFor(model => model.UserId)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserRoleRequest>.CreateWithOptions((CreateNewUserRoleRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
